#include "cuddInt.h"
#include "message.h"

int cuddIncreaseRefSafe(DdManager *manager, DdNodePar f)
{
  if(f.index==CUDD_MAXINDEX)
    return(1);
  if(manager->memory[f.index].PageTable2[f.address.page]==NULL)
    { /* NOTE hashing should be considered */ 
      DdNodeMore *ref_page;
      int i;
      ref_page=manager->memory[f.index].PageTable2[f.address.page] =
	ALLOC(DdNodeMore,DD_MEM_CHUNK)-1;
      if(ref_page==NULL)
	return(0);
      manager->memused+=sizeof(DdNodeMore)*DD_MEM_CHUNK;
      for(i=1;i<=DD_MEM_CHUNK;i++)
	ref_page[i].Reorder.Ref=0;
    }
  cuddIncreaseRef(manager,f);
  return(1);
}
  
